package cz.upol.foolang.ast;

public class BinaryOperator extends Node {

	private final Operator operator;

	public BinaryOperator(Operator operator, Node node1, Node node2) {
		super(node1, node2);
		this.operator = operator;
	}

	public Operator getOperator() {
		return operator;
	}
	
	@Override
	public String toString() {
		return operator.getDescription();
	}
}
