package cz.upol.foolang.ast;

public class Constant extends Node {
	
	private final Class<?> valueClass;
	private final Object value;

	public Constant(Class<?> valueClass, Object value) {
		super();
		this.valueClass = valueClass;
		this.value = value;
	}
	
	@Override
	public String toString() {
		return value + ":" + valueClass.getSimpleName();
	}
}
