// Generated from src/cz/upol/foolang/parser/FooLang.g by ANTLR 4.5.3
package cz.upol.foolang.parser;

import cz.upol.foolang.ast.*;
import cz.upol.foolang.types.*;
import java.util.*;

import org.antlr.v4.runtime.atn.*;
import org.antlr.v4.runtime.dfa.DFA;
import org.antlr.v4.runtime.*;
import org.antlr.v4.runtime.misc.*;
import org.antlr.v4.runtime.tree.*;
import java.util.List;
import java.util.Iterator;
import java.util.ArrayList;

@SuppressWarnings({"all", "warnings", "unchecked", "unused", "cast"})
public class FooLangParser extends Parser {
	static { RuntimeMetaData.checkVersion("4.5.3", RuntimeMetaData.VERSION); }

	protected static final DFA[] _decisionToDFA;
	protected static final PredictionContextCache _sharedContextCache =
		new PredictionContextCache();
	public static final int
		T__0=1, T__1=2, T__2=3, T__3=4, T__4=5, T__5=6, T__6=7, T__7=8, T__8=9, 
		T__9=10, T__10=11, T__11=12, CLASS=13, PRIVATE=14, PUBLIC=15, PROTECTED=16, 
		STATIC=17, RETURN=18, PACKAGE=19, IMPORT=20, T_INT=21, T_BOOLEAN=22, T_DOUBLE=23, 
		T_CHAR=24, T_VOID=25, TRUE=26, FALSE=27, INT=28, FLOAT=29, IDENTIFIER=30, 
		STRING=31, COMMENT=32, WS=33;
	public static final int
		RULE_source = 0, RULE_classDecl = 1, RULE_fieldDecl = 2, RULE_methodDecl = 3, 
		RULE_block = 4, RULE_statement = 5, RULE_varDecl = 6, RULE_arguments = 7, 
		RULE_argument = 8, RULE_modifiers = 9, RULE_scopeDecl = 10, RULE_membershipDecl = 11, 
		RULE_type = 12, RULE_expr = 13, RULE_atom = 14;
	public static final String[] ruleNames = {
		"source", "classDecl", "fieldDecl", "methodDecl", "block", "statement", 
		"varDecl", "arguments", "argument", "modifiers", "scopeDecl", "membershipDecl", 
		"type", "expr", "atom"
	};

	private static final String[] _LITERAL_NAMES = {
		null, "'.'", "';'", "'{'", "'}'", "'('", "','", "')'", "'='", "'+'", "'-'", 
		"'*'", "'/'", "'class'", "'private'", "'public'", "'protected'", "'static'", 
		"'return'", "'package'", "'import'", "'int'", "'boolean'", "'double'", 
		"'char'", "'void'", "'true'", "'false'"
	};
	private static final String[] _SYMBOLIC_NAMES = {
		null, null, null, null, null, null, null, null, null, null, null, null, 
		null, "CLASS", "PRIVATE", "PUBLIC", "PROTECTED", "STATIC", "RETURN", "PACKAGE", 
		"IMPORT", "T_INT", "T_BOOLEAN", "T_DOUBLE", "T_CHAR", "T_VOID", "TRUE", 
		"FALSE", "INT", "FLOAT", "IDENTIFIER", "STRING", "COMMENT", "WS"
	};
	public static final Vocabulary VOCABULARY = new VocabularyImpl(_LITERAL_NAMES, _SYMBOLIC_NAMES);

	/**
	 * @deprecated Use {@link #VOCABULARY} instead.
	 */
	@Deprecated
	public static final String[] tokenNames;
	static {
		tokenNames = new String[_SYMBOLIC_NAMES.length];
		for (int i = 0; i < tokenNames.length; i++) {
			tokenNames[i] = VOCABULARY.getLiteralName(i);
			if (tokenNames[i] == null) {
				tokenNames[i] = VOCABULARY.getSymbolicName(i);
			}

			if (tokenNames[i] == null) {
				tokenNames[i] = "<INVALID>";
			}
		}
	}

	@Override
	@Deprecated
	public String[] getTokenNames() {
		return tokenNames;
	}

	@Override

	public Vocabulary getVocabulary() {
		return VOCABULARY;
	}

	@Override
	public String getGrammarFileName() { return "FooLang.g"; }

	@Override
	public String[] getRuleNames() { return ruleNames; }

	@Override
	public String getSerializedATN() { return _serializedATN; }

	@Override
	public ATN getATN() { return _ATN; }


		
		/** trida sestavujici AST */
		ASTBuilder ast = new ASTBuilder();
		
		/** aktualni balik souboru, definovany 'package' */
		List<String> classPackage = new ArrayList<>();

		/** nazev tridy */
		String className;

		/** jednotlive typy importovane do dane tridy */
		List<GeneralType> imports = new ArrayList<>();

		/** 
	         * pomocna procedura provadejici konverzi escapovanych znaku
	         * na jejich skutecne hodnoty.
	         */  
		public static String unescapeString(String s) {
			StringBuilder result = new StringBuilder();
			for (int i = 0; i < s.length(); i++) {
				char c1 = s.charAt(i);
				if ((c1 == '\\') && (i + 1 < s.length())) {
					char c2 = s.charAt(i + 1);
					switch (c2) {
						case 'n': result.append('\n'); i++; break;
						case 't': result.append('\t'); i++; break;
						case 'r': result.append('\r'); i++; break;
						case '\\': result.append('\\'); i++; break;
						default: result.append(c1);
					}
				} else result.append(c1);
			}
			return result.toString();
		}

		/**
	         * Pro zvoleny typ vraci prislusny balik
	         */
		public List<String> getPackage(String name) {
			if (name.equals(className)) return classPackage;
			
			// hleda prvni vhodny import
			for (GeneralType anImport : imports)
				if (anImport.getTypeName().equals(name)) 
					return anImport.getTypePackage();
			
			// automaticky importuje soubory z java.lang
			try {
				// pokud to neskonci vyjimkou, trida existuje v java.lang
				Class.forName("java.lang." + name);
				return Arrays.asList("java", "lang");
			} catch (ClassNotFoundException e) {
				// ignore this
			}
			throw new RuntimeException("Unknown location of: " + name);
		}

	public FooLangParser(TokenStream input) {
		super(input);
		_interp = new ParserATNSimulator(this,_ATN,_decisionToDFA,_sharedContextCache);
	}
	public static class SourceContext extends ParserRuleContext {
		public Node node;
		public Token pkg;
		public TypeContext type;
		public ClassDeclContext classDecl;
		public ClassDeclContext classDecl() {
			return getRuleContext(ClassDeclContext.class,0);
		}
		public TerminalNode PACKAGE() { return getToken(FooLangParser.PACKAGE, 0); }
		public List<TerminalNode> IMPORT() { return getTokens(FooLangParser.IMPORT); }
		public TerminalNode IMPORT(int i) {
			return getToken(FooLangParser.IMPORT, i);
		}
		public List<TypeContext> type() {
			return getRuleContexts(TypeContext.class);
		}
		public TypeContext type(int i) {
			return getRuleContext(TypeContext.class,i);
		}
		public List<TerminalNode> IDENTIFIER() { return getTokens(FooLangParser.IDENTIFIER); }
		public TerminalNode IDENTIFIER(int i) {
			return getToken(FooLangParser.IDENTIFIER, i);
		}
		public SourceContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_source; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).enterSource(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).exitSource(this);
		}
	}

	public final SourceContext source() throws RecognitionException {
		SourceContext _localctx = new SourceContext(_ctx, getState());
		enterRule(_localctx, 0, RULE_source);
		int _la;
		try {
			int _alt;
			enterOuterAlt(_localctx, 1);
			{
			setState(42);
			_la = _input.LA(1);
			if (_la==PACKAGE) {
				{
				setState(30);
				match(PACKAGE);
				setState(36);
				_errHandler.sync(this);
				_alt = getInterpreter().adaptivePredict(_input,0,_ctx);
				while ( _alt!=2 && _alt!=org.antlr.v4.runtime.atn.ATN.INVALID_ALT_NUMBER ) {
					if ( _alt==1 ) {
						{
						{
						setState(31);
						((SourceContext)_localctx).pkg = match(IDENTIFIER);
						setState(32);
						match(T__0);
						 classPackage.add((((SourceContext)_localctx).pkg!=null?((SourceContext)_localctx).pkg.getText():null)); 
						}
						} 
					}
					setState(38);
					_errHandler.sync(this);
					_alt = getInterpreter().adaptivePredict(_input,0,_ctx);
				}
				setState(39);
				((SourceContext)_localctx).pkg = match(IDENTIFIER);
				 classPackage.add((((SourceContext)_localctx).pkg!=null?((SourceContext)_localctx).pkg.getText():null)); 
				setState(41);
				match(T__1);
				}
			}

			setState(51);
			_errHandler.sync(this);
			_la = _input.LA(1);
			while (_la==IMPORT) {
				{
				{
				setState(44);
				match(IMPORT);
				setState(45);
				((SourceContext)_localctx).type = type();
				 imports.add((GeneralType) ((SourceContext)_localctx).type.name); 
				setState(47);
				match(T__1);
				}
				}
				setState(53);
				_errHandler.sync(this);
				_la = _input.LA(1);
			}
			setState(54);
			((SourceContext)_localctx).classDecl = classDecl();
			 ((SourceContext)_localctx).node =  ((SourceContext)_localctx).classDecl.node; 
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class ClassDeclContext extends ParserRuleContext {
		public Node node;
		public Token name;
		public FieldDeclContext fieldDecl;
		public MethodDeclContext methodDecl;
		public TerminalNode CLASS() { return getToken(FooLangParser.CLASS, 0); }
		public TerminalNode IDENTIFIER() { return getToken(FooLangParser.IDENTIFIER, 0); }
		public List<FieldDeclContext> fieldDecl() {
			return getRuleContexts(FieldDeclContext.class);
		}
		public FieldDeclContext fieldDecl(int i) {
			return getRuleContext(FieldDeclContext.class,i);
		}
		public List<MethodDeclContext> methodDecl() {
			return getRuleContexts(MethodDeclContext.class);
		}
		public MethodDeclContext methodDecl(int i) {
			return getRuleContext(MethodDeclContext.class,i);
		}
		public ClassDeclContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_classDecl; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).enterClassDecl(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).exitClassDecl(this);
		}
	}

	public final ClassDeclContext classDecl() throws RecognitionException {
		ClassDeclContext _localctx = new ClassDeclContext(_ctx, getState());
		enterRule(_localctx, 2, RULE_classDecl);
		int _la;
		try {
			int _alt;
			enterOuterAlt(_localctx, 1);
			{
			 List<Node> ll = new ArrayList<>(); 
			setState(58);
			match(CLASS);
			setState(59);
			((ClassDeclContext)_localctx).name = match(IDENTIFIER);
			 className = (((ClassDeclContext)_localctx).name!=null?((ClassDeclContext)_localctx).name.getText():null); 
			setState(61);
			match(T__2);
			setState(67);
			_errHandler.sync(this);
			_alt = getInterpreter().adaptivePredict(_input,3,_ctx);
			while ( _alt!=2 && _alt!=org.antlr.v4.runtime.atn.ATN.INVALID_ALT_NUMBER ) {
				if ( _alt==1 ) {
					{
					{
					setState(62);
					((ClassDeclContext)_localctx).fieldDecl = fieldDecl();
					 ll.add(((ClassDeclContext)_localctx).fieldDecl.node); 
					}
					} 
				}
				setState(69);
				_errHandler.sync(this);
				_alt = getInterpreter().adaptivePredict(_input,3,_ctx);
			}
			setState(75);
			_errHandler.sync(this);
			_la = _input.LA(1);
			while ((((_la) & ~0x3f) == 0 && ((1L << _la) & ((1L << PRIVATE) | (1L << PUBLIC) | (1L << PROTECTED) | (1L << STATIC))) != 0)) {
				{
				{
				setState(70);
				((ClassDeclContext)_localctx).methodDecl = methodDecl();
				 ll.add(((ClassDeclContext)_localctx).methodDecl.node); 
				}
				}
				setState(77);
				_errHandler.sync(this);
				_la = _input.LA(1);
			}
			setState(78);
			match(T__3);
			 ((ClassDeclContext)_localctx).node =  ast.createClass((((ClassDeclContext)_localctx).name!=null?((ClassDeclContext)_localctx).name.getText():null), ll); 
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class FieldDeclContext extends ParserRuleContext {
		public Node node;
		public ModifiersContext modifiers;
		public TypeContext type;
		public Token name;
		public ModifiersContext modifiers() {
			return getRuleContext(ModifiersContext.class,0);
		}
		public TypeContext type() {
			return getRuleContext(TypeContext.class,0);
		}
		public TerminalNode IDENTIFIER() { return getToken(FooLangParser.IDENTIFIER, 0); }
		public FieldDeclContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_fieldDecl; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).enterFieldDecl(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).exitFieldDecl(this);
		}
	}

	public final FieldDeclContext fieldDecl() throws RecognitionException {
		FieldDeclContext _localctx = new FieldDeclContext(_ctx, getState());
		enterRule(_localctx, 4, RULE_fieldDecl);
		try {
			enterOuterAlt(_localctx, 1);
			{
			setState(81);
			((FieldDeclContext)_localctx).modifiers = modifiers();
			setState(82);
			((FieldDeclContext)_localctx).type = type();
			setState(83);
			((FieldDeclContext)_localctx).name = match(IDENTIFIER);
			setState(84);
			match(T__1);
			 ((FieldDeclContext)_localctx).node =  ast.createField((((FieldDeclContext)_localctx).name!=null?((FieldDeclContext)_localctx).name.getText():null), ((FieldDeclContext)_localctx).modifiers.value, ((FieldDeclContext)_localctx).type.name); 
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class MethodDeclContext extends ParserRuleContext {
		public Node node;
		public ModifiersContext modifiers;
		public TypeContext type;
		public Token name;
		public ArgumentsContext arguments;
		public BlockContext block;
		public ModifiersContext modifiers() {
			return getRuleContext(ModifiersContext.class,0);
		}
		public TypeContext type() {
			return getRuleContext(TypeContext.class,0);
		}
		public ArgumentsContext arguments() {
			return getRuleContext(ArgumentsContext.class,0);
		}
		public BlockContext block() {
			return getRuleContext(BlockContext.class,0);
		}
		public TerminalNode IDENTIFIER() { return getToken(FooLangParser.IDENTIFIER, 0); }
		public MethodDeclContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_methodDecl; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).enterMethodDecl(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).exitMethodDecl(this);
		}
	}

	public final MethodDeclContext methodDecl() throws RecognitionException {
		MethodDeclContext _localctx = new MethodDeclContext(_ctx, getState());
		enterRule(_localctx, 6, RULE_methodDecl);
		try {
			enterOuterAlt(_localctx, 1);
			{
			setState(87);
			((MethodDeclContext)_localctx).modifiers = modifiers();
			setState(88);
			((MethodDeclContext)_localctx).type = type();
			setState(89);
			((MethodDeclContext)_localctx).name = match(IDENTIFIER);
			setState(90);
			((MethodDeclContext)_localctx).arguments = arguments();
			setState(91);
			((MethodDeclContext)_localctx).block = block();
			 ((MethodDeclContext)_localctx).node =  ast.createMethod((((MethodDeclContext)_localctx).name!=null?((MethodDeclContext)_localctx).name.getText():null), ((MethodDeclContext)_localctx).modifiers.value, ((MethodDeclContext)_localctx).type.name, ((MethodDeclContext)_localctx).arguments.arg, ((MethodDeclContext)_localctx).block.node); 
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class BlockContext extends ParserRuleContext {
		public Node node;
		public StatementContext statement;
		public List<StatementContext> statement() {
			return getRuleContexts(StatementContext.class);
		}
		public StatementContext statement(int i) {
			return getRuleContext(StatementContext.class,i);
		}
		public BlockContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_block; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).enterBlock(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).exitBlock(this);
		}
	}

	public final BlockContext block() throws RecognitionException {
		BlockContext _localctx = new BlockContext(_ctx, getState());
		enterRule(_localctx, 8, RULE_block);
		int _la;
		try {
			enterOuterAlt(_localctx, 1);
			{
			 List<Node> ll = new ArrayList<>(); 
			setState(95);
			match(T__2);
			setState(101);
			_errHandler.sync(this);
			_la = _input.LA(1);
			while ((((_la) & ~0x3f) == 0 && ((1L << _la) & ((1L << RETURN) | (1L << T_INT) | (1L << T_BOOLEAN) | (1L << T_DOUBLE) | (1L << T_CHAR) | (1L << T_VOID) | (1L << IDENTIFIER))) != 0)) {
				{
				{
				setState(96);
				((BlockContext)_localctx).statement = statement();
				 ll.add(((BlockContext)_localctx).statement.node); 
				}
				}
				setState(103);
				_errHandler.sync(this);
				_la = _input.LA(1);
			}
			setState(104);
			match(T__3);
			 ((BlockContext)_localctx).node =  ast.createBlock(ll); 
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class StatementContext extends ParserRuleContext {
		public Node node;
		public VarDeclContext varDecl;
		public ExprContext expr;
		public VarDeclContext varDecl() {
			return getRuleContext(VarDeclContext.class,0);
		}
		public TerminalNode RETURN() { return getToken(FooLangParser.RETURN, 0); }
		public ExprContext expr() {
			return getRuleContext(ExprContext.class,0);
		}
		public StatementContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_statement; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).enterStatement(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).exitStatement(this);
		}
	}

	public final StatementContext statement() throws RecognitionException {
		StatementContext _localctx = new StatementContext(_ctx, getState());
		enterRule(_localctx, 10, RULE_statement);
		try {
			setState(116);
			switch (_input.LA(1)) {
			case T_INT:
			case T_BOOLEAN:
			case T_DOUBLE:
			case T_CHAR:
			case T_VOID:
			case IDENTIFIER:
				enterOuterAlt(_localctx, 1);
				{
				setState(107);
				((StatementContext)_localctx).varDecl = varDecl();
				setState(108);
				match(T__1);
				 ((StatementContext)_localctx).node =  ((StatementContext)_localctx).varDecl.node; 
				}
				break;
			case RETURN:
				enterOuterAlt(_localctx, 2);
				{
				setState(111);
				match(RETURN);
				setState(112);
				((StatementContext)_localctx).expr = expr(0);
				setState(113);
				match(T__1);
				 ((StatementContext)_localctx).node =  ast.createReturn(((StatementContext)_localctx).expr.node); 
				}
				break;
			default:
				throw new NoViableAltException(this);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class VarDeclContext extends ParserRuleContext {
		public Node node;
		public TypeContext type;
		public Token name;
		public TypeContext type() {
			return getRuleContext(TypeContext.class,0);
		}
		public TerminalNode IDENTIFIER() { return getToken(FooLangParser.IDENTIFIER, 0); }
		public VarDeclContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_varDecl; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).enterVarDecl(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).exitVarDecl(this);
		}
	}

	public final VarDeclContext varDecl() throws RecognitionException {
		VarDeclContext _localctx = new VarDeclContext(_ctx, getState());
		enterRule(_localctx, 12, RULE_varDecl);
		try {
			enterOuterAlt(_localctx, 1);
			{
			setState(118);
			((VarDeclContext)_localctx).type = type();
			setState(119);
			((VarDeclContext)_localctx).name = match(IDENTIFIER);
			 ((VarDeclContext)_localctx).node =  ast.createVarDecl((((VarDeclContext)_localctx).name!=null?((VarDeclContext)_localctx).name.getText():null), ((VarDeclContext)_localctx).type.name); 
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class ArgumentsContext extends ParserRuleContext {
		public List<Argument> arg;
		public ArgumentContext argument;
		public List<ArgumentContext> argument() {
			return getRuleContexts(ArgumentContext.class);
		}
		public ArgumentContext argument(int i) {
			return getRuleContext(ArgumentContext.class,i);
		}
		public ArgumentsContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_arguments; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).enterArguments(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).exitArguments(this);
		}
	}

	public final ArgumentsContext arguments() throws RecognitionException {
		ArgumentsContext _localctx = new ArgumentsContext(_ctx, getState());
		enterRule(_localctx, 14, RULE_arguments);
		int _la;
		try {
			enterOuterAlt(_localctx, 1);
			{
			 List<Argument> ll = new ArrayList<>(); 
			setState(123);
			match(T__4);
			setState(127);
			_la = _input.LA(1);
			if ((((_la) & ~0x3f) == 0 && ((1L << _la) & ((1L << T_INT) | (1L << T_BOOLEAN) | (1L << T_DOUBLE) | (1L << T_CHAR) | (1L << T_VOID) | (1L << IDENTIFIER))) != 0)) {
				{
				setState(124);
				((ArgumentsContext)_localctx).argument = argument();
				 ll.add(((ArgumentsContext)_localctx).argument.arg); 
				}
			}

			setState(135);
			_errHandler.sync(this);
			_la = _input.LA(1);
			while (_la==T__5) {
				{
				{
				setState(129);
				match(T__5);
				setState(130);
				((ArgumentsContext)_localctx).argument = argument();
				 ll.add(((ArgumentsContext)_localctx).argument.arg); 
				}
				}
				setState(137);
				_errHandler.sync(this);
				_la = _input.LA(1);
			}
			setState(138);
			match(T__6);
			 ((ArgumentsContext)_localctx).arg =  ll; 
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class ArgumentContext extends ParserRuleContext {
		public Argument arg;
		public TypeContext type;
		public Token name;
		public TypeContext type() {
			return getRuleContext(TypeContext.class,0);
		}
		public TerminalNode IDENTIFIER() { return getToken(FooLangParser.IDENTIFIER, 0); }
		public ArgumentContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_argument; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).enterArgument(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).exitArgument(this);
		}
	}

	public final ArgumentContext argument() throws RecognitionException {
		ArgumentContext _localctx = new ArgumentContext(_ctx, getState());
		enterRule(_localctx, 16, RULE_argument);
		try {
			enterOuterAlt(_localctx, 1);
			{
			setState(141);
			((ArgumentContext)_localctx).type = type();
			setState(142);
			((ArgumentContext)_localctx).name = match(IDENTIFIER);
			 ((ArgumentContext)_localctx).arg =  ast.createArgument(((ArgumentContext)_localctx).type.name, (((ArgumentContext)_localctx).name!=null?((ArgumentContext)_localctx).name.getText():null)); 
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class ModifiersContext extends ParserRuleContext {
		public Set<Modifier> value;
		public ScopeDeclContext sd;
		public MembershipDeclContext md;
		public ScopeDeclContext scopeDecl() {
			return getRuleContext(ScopeDeclContext.class,0);
		}
		public MembershipDeclContext membershipDecl() {
			return getRuleContext(MembershipDeclContext.class,0);
		}
		public ModifiersContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_modifiers; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).enterModifiers(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).exitModifiers(this);
		}
	}

	public final ModifiersContext modifiers() throws RecognitionException {
		ModifiersContext _localctx = new ModifiersContext(_ctx, getState());
		enterRule(_localctx, 18, RULE_modifiers);
		int _la;
		try {
			setState(167);
			_errHandler.sync(this);
			switch ( getInterpreter().adaptivePredict(_input,11,_ctx) ) {
			case 1:
				enterOuterAlt(_localctx, 1);
				{
				 Set<Modifier> ss = new HashSet<>(); 
				{
				setState(146);
				((ModifiersContext)_localctx).sd = scopeDecl();
				 ss.add(((ModifiersContext)_localctx).sd.value); 
				}
				setState(152);
				_la = _input.LA(1);
				if (_la==STATIC) {
					{
					setState(149);
					((ModifiersContext)_localctx).md = membershipDecl();
					 ss.add(((ModifiersContext)_localctx).md.value); 
					}
				}

				 ((ModifiersContext)_localctx).value =  ss; 
				}
				break;
			case 2:
				enterOuterAlt(_localctx, 2);
				{
				 Set<Modifier> ss = new HashSet<>(); 
				setState(160);
				_la = _input.LA(1);
				if (_la==STATIC) {
					{
					setState(157);
					((ModifiersContext)_localctx).md = membershipDecl();
					 ss.add(((ModifiersContext)_localctx).md.value); 
					}
				}

				{
				setState(162);
				((ModifiersContext)_localctx).sd = scopeDecl();
				 ss.add(((ModifiersContext)_localctx).sd.value); 
				}
				 ((ModifiersContext)_localctx).value =  ss; 
				}
				break;
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class ScopeDeclContext extends ParserRuleContext {
		public Modifier value;
		public TerminalNode PRIVATE() { return getToken(FooLangParser.PRIVATE, 0); }
		public TerminalNode PUBLIC() { return getToken(FooLangParser.PUBLIC, 0); }
		public TerminalNode PROTECTED() { return getToken(FooLangParser.PROTECTED, 0); }
		public ScopeDeclContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_scopeDecl; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).enterScopeDecl(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).exitScopeDecl(this);
		}
	}

	public final ScopeDeclContext scopeDecl() throws RecognitionException {
		ScopeDeclContext _localctx = new ScopeDeclContext(_ctx, getState());
		enterRule(_localctx, 20, RULE_scopeDecl);
		try {
			setState(175);
			switch (_input.LA(1)) {
			case PRIVATE:
				enterOuterAlt(_localctx, 1);
				{
				setState(169);
				match(PRIVATE);
				 ((ScopeDeclContext)_localctx).value =  Modifier.PRIVATE; 
				}
				break;
			case PUBLIC:
				enterOuterAlt(_localctx, 2);
				{
				setState(171);
				match(PUBLIC);
				 ((ScopeDeclContext)_localctx).value =  Modifier.PUBLIC; 
				}
				break;
			case PROTECTED:
				enterOuterAlt(_localctx, 3);
				{
				setState(173);
				match(PROTECTED);
				 ((ScopeDeclContext)_localctx).value =  Modifier.PROTECTED; 
				}
				break;
			default:
				throw new NoViableAltException(this);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class MembershipDeclContext extends ParserRuleContext {
		public Modifier value;
		public TerminalNode STATIC() { return getToken(FooLangParser.STATIC, 0); }
		public MembershipDeclContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_membershipDecl; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).enterMembershipDecl(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).exitMembershipDecl(this);
		}
	}

	public final MembershipDeclContext membershipDecl() throws RecognitionException {
		MembershipDeclContext _localctx = new MembershipDeclContext(_ctx, getState());
		enterRule(_localctx, 22, RULE_membershipDecl);
		try {
			enterOuterAlt(_localctx, 1);
			{
			setState(177);
			match(STATIC);
			 ((MembershipDeclContext)_localctx).value =  Modifier.STATIC; 
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class TypeContext extends ParserRuleContext {
		public Type name;
		public Token pkg;
		public Token typeName;
		public TerminalNode T_INT() { return getToken(FooLangParser.T_INT, 0); }
		public TerminalNode T_BOOLEAN() { return getToken(FooLangParser.T_BOOLEAN, 0); }
		public TerminalNode T_DOUBLE() { return getToken(FooLangParser.T_DOUBLE, 0); }
		public TerminalNode T_CHAR() { return getToken(FooLangParser.T_CHAR, 0); }
		public TerminalNode T_VOID() { return getToken(FooLangParser.T_VOID, 0); }
		public List<TerminalNode> IDENTIFIER() { return getTokens(FooLangParser.IDENTIFIER); }
		public TerminalNode IDENTIFIER(int i) {
			return getToken(FooLangParser.IDENTIFIER, i);
		}
		public TypeContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_type; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).enterType(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).exitType(this);
		}
	}

	public final TypeContext type() throws RecognitionException {
		TypeContext _localctx = new TypeContext(_ctx, getState());
		enterRule(_localctx, 24, RULE_type);
		try {
			int _alt;
			setState(202);
			_errHandler.sync(this);
			switch ( getInterpreter().adaptivePredict(_input,14,_ctx) ) {
			case 1:
				enterOuterAlt(_localctx, 1);
				{
				}
				break;
			case 2:
				enterOuterAlt(_localctx, 2);
				{
				setState(181);
				match(T_INT);
				 ((TypeContext)_localctx).name =  PrimitiveType.INT; 
				}
				break;
			case 3:
				enterOuterAlt(_localctx, 3);
				{
				setState(183);
				match(T_BOOLEAN);
				 ((TypeContext)_localctx).name =  PrimitiveType.BOOLEAN; 
				}
				break;
			case 4:
				enterOuterAlt(_localctx, 4);
				{
				setState(185);
				match(T_DOUBLE);
				 ((TypeContext)_localctx).name =  PrimitiveType.DOUBLE; 
				}
				break;
			case 5:
				enterOuterAlt(_localctx, 5);
				{
				setState(187);
				match(T_CHAR);
				 ((TypeContext)_localctx).name =  PrimitiveType.CHAR; 
				}
				break;
			case 6:
				enterOuterAlt(_localctx, 6);
				{
				setState(189);
				match(T_VOID);
				 ((TypeContext)_localctx).name =  PrimitiveType.VOID; 
				}
				break;
			case 7:
				enterOuterAlt(_localctx, 7);
				{
				 List<String> ll = new ArrayList<>(); 
				setState(197);
				_errHandler.sync(this);
				_alt = getInterpreter().adaptivePredict(_input,13,_ctx);
				while ( _alt!=2 && _alt!=org.antlr.v4.runtime.atn.ATN.INVALID_ALT_NUMBER ) {
					if ( _alt==1 ) {
						{
						{
						setState(192);
						((TypeContext)_localctx).pkg = match(IDENTIFIER);
						setState(193);
						match(T__0);
						 ll.add((((TypeContext)_localctx).pkg!=null?((TypeContext)_localctx).pkg.getText():null)); 
						}
						} 
					}
					setState(199);
					_errHandler.sync(this);
					_alt = getInterpreter().adaptivePredict(_input,13,_ctx);
				}
				setState(200);
				((TypeContext)_localctx).typeName = match(IDENTIFIER);
				 ((TypeContext)_localctx).name =  ast.createType(ll.size() > 0 ? ll : getPackage((((TypeContext)_localctx).typeName!=null?((TypeContext)_localctx).typeName.getText():null)), (((TypeContext)_localctx).typeName!=null?((TypeContext)_localctx).typeName.getText():null)); 
				}
				break;
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class ExprContext extends ParserRuleContext {
		public Node node;
		public ExprContext e1;
		public AtomContext atom;
		public ExprContext expr;
		public ExprContext e2;
		public AtomContext atom() {
			return getRuleContext(AtomContext.class,0);
		}
		public List<ExprContext> expr() {
			return getRuleContexts(ExprContext.class);
		}
		public ExprContext expr(int i) {
			return getRuleContext(ExprContext.class,i);
		}
		public ExprContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_expr; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).enterExpr(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).exitExpr(this);
		}
	}

	public final ExprContext expr() throws RecognitionException {
		return expr(0);
	}

	private ExprContext expr(int _p) throws RecognitionException {
		ParserRuleContext _parentctx = _ctx;
		int _parentState = getState();
		ExprContext _localctx = new ExprContext(_ctx, _parentState);
		ExprContext _prevctx = _localctx;
		int _startState = 26;
		enterRecursionRule(_localctx, 26, RULE_expr, _p);
		try {
			int _alt;
			enterOuterAlt(_localctx, 1);
			{
			setState(213);
			switch (_input.LA(1)) {
			case TRUE:
			case FALSE:
			case INT:
			case FLOAT:
			case IDENTIFIER:
			case STRING:
				{
				setState(205);
				((ExprContext)_localctx).atom = atom();
				 ((ExprContext)_localctx).node =  ((ExprContext)_localctx).atom.node; 
				}
				break;
			case T__4:
				{
				setState(208);
				match(T__4);
				setState(209);
				((ExprContext)_localctx).expr = expr(0);
				setState(210);
				match(T__6);
				 ((ExprContext)_localctx).node =  _localctx.node; 
				}
				break;
			default:
				throw new NoViableAltException(this);
			}
			_ctx.stop = _input.LT(-1);
			setState(242);
			_errHandler.sync(this);
			_alt = getInterpreter().adaptivePredict(_input,17,_ctx);
			while ( _alt!=2 && _alt!=org.antlr.v4.runtime.atn.ATN.INVALID_ALT_NUMBER ) {
				if ( _alt==1 ) {
					if ( _parseListeners!=null ) triggerExitRuleEvent();
					_prevctx = _localctx;
					{
					setState(240);
					_errHandler.sync(this);
					switch ( getInterpreter().adaptivePredict(_input,16,_ctx) ) {
					case 1:
						{
						_localctx = new ExprContext(_parentctx, _parentState);
						_localctx.e1 = _prevctx;
						_localctx.e1 = _prevctx;
						pushNewRecursionContext(_localctx, _startState, RULE_expr);
						setState(215);
						if (!(precpred(_ctx, 5))) throw new FailedPredicateException(this, "precpred(_ctx, 5)");
						setState(216);
						match(T__7);
						setState(217);
						((ExprContext)_localctx).e2 = ((ExprContext)_localctx).expr = expr(6);
						 ((ExprContext)_localctx).node =  ast.createBinaryOperator(Operator.ASSIGN, ((ExprContext)_localctx).e1.node, ((ExprContext)_localctx).e2.node); 
						}
						break;
					case 2:
						{
						_localctx = new ExprContext(_parentctx, _parentState);
						_localctx.e1 = _prevctx;
						_localctx.e1 = _prevctx;
						pushNewRecursionContext(_localctx, _startState, RULE_expr);
						setState(220);
						if (!(precpred(_ctx, 4))) throw new FailedPredicateException(this, "precpred(_ctx, 4)");
						setState(221);
						match(T__8);
						setState(222);
						((ExprContext)_localctx).e2 = ((ExprContext)_localctx).expr = expr(5);
						 ((ExprContext)_localctx).node =  ast.createBinaryOperator(Operator.ADD, ((ExprContext)_localctx).e1.node, ((ExprContext)_localctx).e2.node); 
						}
						break;
					case 3:
						{
						_localctx = new ExprContext(_parentctx, _parentState);
						_localctx.e1 = _prevctx;
						_localctx.e1 = _prevctx;
						pushNewRecursionContext(_localctx, _startState, RULE_expr);
						setState(225);
						if (!(precpred(_ctx, 3))) throw new FailedPredicateException(this, "precpred(_ctx, 3)");
						setState(226);
						match(T__9);
						setState(227);
						((ExprContext)_localctx).e2 = ((ExprContext)_localctx).expr = expr(4);
						 ((ExprContext)_localctx).node =  ast.createBinaryOperator(Operator.SUB, ((ExprContext)_localctx).e1.node, ((ExprContext)_localctx).e2.node); 
						}
						break;
					case 4:
						{
						_localctx = new ExprContext(_parentctx, _parentState);
						_localctx.e1 = _prevctx;
						_localctx.e1 = _prevctx;
						pushNewRecursionContext(_localctx, _startState, RULE_expr);
						setState(230);
						if (!(precpred(_ctx, 2))) throw new FailedPredicateException(this, "precpred(_ctx, 2)");
						setState(231);
						match(T__10);
						setState(232);
						((ExprContext)_localctx).e2 = ((ExprContext)_localctx).expr = expr(3);
						 ((ExprContext)_localctx).node =  ast.createBinaryOperator(Operator.MUL, ((ExprContext)_localctx).e1.node, ((ExprContext)_localctx).e2.node); 
						}
						break;
					case 5:
						{
						_localctx = new ExprContext(_parentctx, _parentState);
						_localctx.e1 = _prevctx;
						_localctx.e1 = _prevctx;
						pushNewRecursionContext(_localctx, _startState, RULE_expr);
						setState(235);
						if (!(precpred(_ctx, 1))) throw new FailedPredicateException(this, "precpred(_ctx, 1)");
						setState(236);
						match(T__11);
						setState(237);
						((ExprContext)_localctx).e2 = ((ExprContext)_localctx).expr = expr(2);
						 ((ExprContext)_localctx).node =  ast.createBinaryOperator(Operator.DIV, ((ExprContext)_localctx).e1.node, ((ExprContext)_localctx).e2.node); 
						}
						break;
					}
					} 
				}
				setState(244);
				_errHandler.sync(this);
				_alt = getInterpreter().adaptivePredict(_input,17,_ctx);
			}
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			unrollRecursionContexts(_parentctx);
		}
		return _localctx;
	}

	public static class AtomContext extends ParserRuleContext {
		public Node node;
		public Token INT;
		public Token FLOAT;
		public Token IDENTIFIER;
		public Token STRING;
		public TerminalNode INT() { return getToken(FooLangParser.INT, 0); }
		public TerminalNode FLOAT() { return getToken(FooLangParser.FLOAT, 0); }
		public TerminalNode IDENTIFIER() { return getToken(FooLangParser.IDENTIFIER, 0); }
		public TerminalNode TRUE() { return getToken(FooLangParser.TRUE, 0); }
		public TerminalNode FALSE() { return getToken(FooLangParser.FALSE, 0); }
		public TerminalNode STRING() { return getToken(FooLangParser.STRING, 0); }
		public AtomContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_atom; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).enterAtom(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof FooLangListener ) ((FooLangListener)listener).exitAtom(this);
		}
	}

	public final AtomContext atom() throws RecognitionException {
		AtomContext _localctx = new AtomContext(_ctx, getState());
		enterRule(_localctx, 28, RULE_atom);
		try {
			setState(257);
			switch (_input.LA(1)) {
			case INT:
				enterOuterAlt(_localctx, 1);
				{
				setState(245);
				((AtomContext)_localctx).INT = match(INT);
				 ((AtomContext)_localctx).node =  ast.createConstant(Integer.parseInt((((AtomContext)_localctx).INT!=null?((AtomContext)_localctx).INT.getText():null))); 
				}
				break;
			case FLOAT:
				enterOuterAlt(_localctx, 2);
				{
				setState(247);
				((AtomContext)_localctx).FLOAT = match(FLOAT);
				 ((AtomContext)_localctx).node =  ast.createConstant(Double.parseDouble((((AtomContext)_localctx).FLOAT!=null?((AtomContext)_localctx).FLOAT.getText():null))); 
				}
				break;
			case IDENTIFIER:
				enterOuterAlt(_localctx, 3);
				{
				setState(249);
				((AtomContext)_localctx).IDENTIFIER = match(IDENTIFIER);
				 ((AtomContext)_localctx).node =  ast.createVariable((((AtomContext)_localctx).IDENTIFIER!=null?((AtomContext)_localctx).IDENTIFIER.getText():null)); 
				}
				break;
			case TRUE:
				enterOuterAlt(_localctx, 4);
				{
				setState(251);
				match(TRUE);
				 ((AtomContext)_localctx).node =  ast.createConstant(true); 
				}
				break;
			case FALSE:
				enterOuterAlt(_localctx, 5);
				{
				setState(253);
				match(FALSE);
				 ((AtomContext)_localctx).node =  ast.createConstant(false); 
				}
				break;
			case STRING:
				enterOuterAlt(_localctx, 6);
				{
				setState(255);
				((AtomContext)_localctx).STRING = match(STRING);
				 ((AtomContext)_localctx).node =  ast.createConstant(unescapeString((((AtomContext)_localctx).STRING!=null?((AtomContext)_localctx).STRING.getText():null).substring(1, (((AtomContext)_localctx).STRING!=null?((AtomContext)_localctx).STRING.getText():null).length() - 1))); 
				}
				break;
			default:
				throw new NoViableAltException(this);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public boolean sempred(RuleContext _localctx, int ruleIndex, int predIndex) {
		switch (ruleIndex) {
		case 13:
			return expr_sempred((ExprContext)_localctx, predIndex);
		}
		return true;
	}
	private boolean expr_sempred(ExprContext _localctx, int predIndex) {
		switch (predIndex) {
		case 0:
			return precpred(_ctx, 5);
		case 1:
			return precpred(_ctx, 4);
		case 2:
			return precpred(_ctx, 3);
		case 3:
			return precpred(_ctx, 2);
		case 4:
			return precpred(_ctx, 1);
		}
		return true;
	}

	public static final String _serializedATN =
		"\3\u0430\ud6d1\u8206\uad2d\u4417\uaef1\u8d80\uaadd\3#\u0106\4\2\t\2\4"+
		"\3\t\3\4\4\t\4\4\5\t\5\4\6\t\6\4\7\t\7\4\b\t\b\4\t\t\t\4\n\t\n\4\13\t"+
		"\13\4\f\t\f\4\r\t\r\4\16\t\16\4\17\t\17\4\20\t\20\3\2\3\2\3\2\3\2\7\2"+
		"%\n\2\f\2\16\2(\13\2\3\2\3\2\3\2\5\2-\n\2\3\2\3\2\3\2\3\2\3\2\7\2\64\n"+
		"\2\f\2\16\2\67\13\2\3\2\3\2\3\2\3\3\3\3\3\3\3\3\3\3\3\3\3\3\3\3\7\3D\n"+
		"\3\f\3\16\3G\13\3\3\3\3\3\3\3\7\3L\n\3\f\3\16\3O\13\3\3\3\3\3\3\3\3\4"+
		"\3\4\3\4\3\4\3\4\3\4\3\5\3\5\3\5\3\5\3\5\3\5\3\5\3\6\3\6\3\6\3\6\3\6\7"+
		"\6f\n\6\f\6\16\6i\13\6\3\6\3\6\3\6\3\7\3\7\3\7\3\7\3\7\3\7\3\7\3\7\3\7"+
		"\5\7w\n\7\3\b\3\b\3\b\3\b\3\t\3\t\3\t\3\t\3\t\5\t\u0082\n\t\3\t\3\t\3"+
		"\t\3\t\7\t\u0088\n\t\f\t\16\t\u008b\13\t\3\t\3\t\3\t\3\n\3\n\3\n\3\n\3"+
		"\13\3\13\3\13\3\13\3\13\3\13\3\13\5\13\u009b\n\13\3\13\3\13\3\13\3\13"+
		"\3\13\3\13\5\13\u00a3\n\13\3\13\3\13\3\13\3\13\3\13\5\13\u00aa\n\13\3"+
		"\f\3\f\3\f\3\f\3\f\3\f\5\f\u00b2\n\f\3\r\3\r\3\r\3\16\3\16\3\16\3\16\3"+
		"\16\3\16\3\16\3\16\3\16\3\16\3\16\3\16\3\16\3\16\3\16\7\16\u00c6\n\16"+
		"\f\16\16\16\u00c9\13\16\3\16\3\16\5\16\u00cd\n\16\3\17\3\17\3\17\3\17"+
		"\3\17\3\17\3\17\3\17\3\17\5\17\u00d8\n\17\3\17\3\17\3\17\3\17\3\17\3\17"+
		"\3\17\3\17\3\17\3\17\3\17\3\17\3\17\3\17\3\17\3\17\3\17\3\17\3\17\3\17"+
		"\3\17\3\17\3\17\3\17\3\17\7\17\u00f3\n\17\f\17\16\17\u00f6\13\17\3\20"+
		"\3\20\3\20\3\20\3\20\3\20\3\20\3\20\3\20\3\20\3\20\3\20\5\20\u0104\n\20"+
		"\3\20\2\3\34\21\2\4\6\b\n\f\16\20\22\24\26\30\32\34\36\2\2\u0116\2,\3"+
		"\2\2\2\4;\3\2\2\2\6S\3\2\2\2\bY\3\2\2\2\n`\3\2\2\2\fv\3\2\2\2\16x\3\2"+
		"\2\2\20|\3\2\2\2\22\u008f\3\2\2\2\24\u00a9\3\2\2\2\26\u00b1\3\2\2\2\30"+
		"\u00b3\3\2\2\2\32\u00cc\3\2\2\2\34\u00d7\3\2\2\2\36\u0103\3\2\2\2 &\7"+
		"\25\2\2!\"\7 \2\2\"#\7\3\2\2#%\b\2\1\2$!\3\2\2\2%(\3\2\2\2&$\3\2\2\2&"+
		"\'\3\2\2\2\')\3\2\2\2(&\3\2\2\2)*\7 \2\2*+\b\2\1\2+-\7\4\2\2, \3\2\2\2"+
		",-\3\2\2\2-\65\3\2\2\2./\7\26\2\2/\60\5\32\16\2\60\61\b\2\1\2\61\62\7"+
		"\4\2\2\62\64\3\2\2\2\63.\3\2\2\2\64\67\3\2\2\2\65\63\3\2\2\2\65\66\3\2"+
		"\2\2\668\3\2\2\2\67\65\3\2\2\289\5\4\3\29:\b\2\1\2:\3\3\2\2\2;<\b\3\1"+
		"\2<=\7\17\2\2=>\7 \2\2>?\b\3\1\2?E\7\5\2\2@A\5\6\4\2AB\b\3\1\2BD\3\2\2"+
		"\2C@\3\2\2\2DG\3\2\2\2EC\3\2\2\2EF\3\2\2\2FM\3\2\2\2GE\3\2\2\2HI\5\b\5"+
		"\2IJ\b\3\1\2JL\3\2\2\2KH\3\2\2\2LO\3\2\2\2MK\3\2\2\2MN\3\2\2\2NP\3\2\2"+
		"\2OM\3\2\2\2PQ\7\6\2\2QR\b\3\1\2R\5\3\2\2\2ST\5\24\13\2TU\5\32\16\2UV"+
		"\7 \2\2VW\7\4\2\2WX\b\4\1\2X\7\3\2\2\2YZ\5\24\13\2Z[\5\32\16\2[\\\7 \2"+
		"\2\\]\5\20\t\2]^\5\n\6\2^_\b\5\1\2_\t\3\2\2\2`a\b\6\1\2ag\7\5\2\2bc\5"+
		"\f\7\2cd\b\6\1\2df\3\2\2\2eb\3\2\2\2fi\3\2\2\2ge\3\2\2\2gh\3\2\2\2hj\3"+
		"\2\2\2ig\3\2\2\2jk\7\6\2\2kl\b\6\1\2l\13\3\2\2\2mn\5\16\b\2no\7\4\2\2"+
		"op\b\7\1\2pw\3\2\2\2qr\7\24\2\2rs\5\34\17\2st\7\4\2\2tu\b\7\1\2uw\3\2"+
		"\2\2vm\3\2\2\2vq\3\2\2\2w\r\3\2\2\2xy\5\32\16\2yz\7 \2\2z{\b\b\1\2{\17"+
		"\3\2\2\2|}\b\t\1\2}\u0081\7\7\2\2~\177\5\22\n\2\177\u0080\b\t\1\2\u0080"+
		"\u0082\3\2\2\2\u0081~\3\2\2\2\u0081\u0082\3\2\2\2\u0082\u0089\3\2\2\2"+
		"\u0083\u0084\7\b\2\2\u0084\u0085\5\22\n\2\u0085\u0086\b\t\1\2\u0086\u0088"+
		"\3\2\2\2\u0087\u0083\3\2\2\2\u0088\u008b\3\2\2\2\u0089\u0087\3\2\2\2\u0089"+
		"\u008a\3\2\2\2\u008a\u008c\3\2\2\2\u008b\u0089\3\2\2\2\u008c\u008d\7\t"+
		"\2\2\u008d\u008e\b\t\1\2\u008e\21\3\2\2\2\u008f\u0090\5\32\16\2\u0090"+
		"\u0091\7 \2\2\u0091\u0092\b\n\1\2\u0092\23\3\2\2\2\u0093\u0094\b\13\1"+
		"\2\u0094\u0095\5\26\f\2\u0095\u0096\b\13\1\2\u0096\u009a\3\2\2\2\u0097"+
		"\u0098\5\30\r\2\u0098\u0099\b\13\1\2\u0099\u009b\3\2\2\2\u009a\u0097\3"+
		"\2\2\2\u009a\u009b\3\2\2\2\u009b\u009c\3\2\2\2\u009c\u009d\b\13\1\2\u009d"+
		"\u00aa\3\2\2\2\u009e\u00a2\b\13\1\2\u009f\u00a0\5\30\r\2\u00a0\u00a1\b"+
		"\13\1\2\u00a1\u00a3\3\2\2\2\u00a2\u009f\3\2\2\2\u00a2\u00a3\3\2\2\2\u00a3"+
		"\u00a4\3\2\2\2\u00a4\u00a5\5\26\f\2\u00a5\u00a6\b\13\1\2\u00a6\u00a7\3"+
		"\2\2\2\u00a7\u00a8\b\13\1\2\u00a8\u00aa\3\2\2\2\u00a9\u0093\3\2\2\2\u00a9"+
		"\u009e\3\2\2\2\u00aa\25\3\2\2\2\u00ab\u00ac\7\20\2\2\u00ac\u00b2\b\f\1"+
		"\2\u00ad\u00ae\7\21\2\2\u00ae\u00b2\b\f\1\2\u00af\u00b0\7\22\2\2\u00b0"+
		"\u00b2\b\f\1\2\u00b1\u00ab\3\2\2\2\u00b1\u00ad\3\2\2\2\u00b1\u00af\3\2"+
		"\2\2\u00b2\27\3\2\2\2\u00b3\u00b4\7\23\2\2\u00b4\u00b5\b\r\1\2\u00b5\31"+
		"\3\2\2\2\u00b6\u00cd\3\2\2\2\u00b7\u00b8\7\27\2\2\u00b8\u00cd\b\16\1\2"+
		"\u00b9\u00ba\7\30\2\2\u00ba\u00cd\b\16\1\2\u00bb\u00bc\7\31\2\2\u00bc"+
		"\u00cd\b\16\1\2\u00bd\u00be\7\32\2\2\u00be\u00cd\b\16\1\2\u00bf\u00c0"+
		"\7\33\2\2\u00c0\u00cd\b\16\1\2\u00c1\u00c7\b\16\1\2\u00c2\u00c3\7 \2\2"+
		"\u00c3\u00c4\7\3\2\2\u00c4\u00c6\b\16\1\2\u00c5\u00c2\3\2\2\2\u00c6\u00c9"+
		"\3\2\2\2\u00c7\u00c5\3\2\2\2\u00c7\u00c8\3\2\2\2\u00c8\u00ca\3\2\2\2\u00c9"+
		"\u00c7\3\2\2\2\u00ca\u00cb\7 \2\2\u00cb\u00cd\b\16\1\2\u00cc\u00b6\3\2"+
		"\2\2\u00cc\u00b7\3\2\2\2\u00cc\u00b9\3\2\2\2\u00cc\u00bb\3\2\2\2\u00cc"+
		"\u00bd\3\2\2\2\u00cc\u00bf\3\2\2\2\u00cc\u00c1\3\2\2\2\u00cd\33\3\2\2"+
		"\2\u00ce\u00cf\b\17\1\2\u00cf\u00d0\5\36\20\2\u00d0\u00d1\b\17\1\2\u00d1"+
		"\u00d8\3\2\2\2\u00d2\u00d3\7\7\2\2\u00d3\u00d4\5\34\17\2\u00d4\u00d5\7"+
		"\t\2\2\u00d5\u00d6\b\17\1\2\u00d6\u00d8\3\2\2\2\u00d7\u00ce\3\2\2\2\u00d7"+
		"\u00d2\3\2\2\2\u00d8\u00f4\3\2\2\2\u00d9\u00da\f\7\2\2\u00da\u00db\7\n"+
		"\2\2\u00db\u00dc\5\34\17\b\u00dc\u00dd\b\17\1\2\u00dd\u00f3\3\2\2\2\u00de"+
		"\u00df\f\6\2\2\u00df\u00e0\7\13\2\2\u00e0\u00e1\5\34\17\7\u00e1\u00e2"+
		"\b\17\1\2\u00e2\u00f3\3\2\2\2\u00e3\u00e4\f\5\2\2\u00e4\u00e5\7\f\2\2"+
		"\u00e5\u00e6\5\34\17\6\u00e6\u00e7\b\17\1\2\u00e7\u00f3\3\2\2\2\u00e8"+
		"\u00e9\f\4\2\2\u00e9\u00ea\7\r\2\2\u00ea\u00eb\5\34\17\5\u00eb\u00ec\b"+
		"\17\1\2\u00ec\u00f3\3\2\2\2\u00ed\u00ee\f\3\2\2\u00ee\u00ef\7\16\2\2\u00ef"+
		"\u00f0\5\34\17\4\u00f0\u00f1\b\17\1\2\u00f1\u00f3\3\2\2\2\u00f2\u00d9"+
		"\3\2\2\2\u00f2\u00de\3\2\2\2\u00f2\u00e3\3\2\2\2\u00f2\u00e8\3\2\2\2\u00f2"+
		"\u00ed\3\2\2\2\u00f3\u00f6\3\2\2\2\u00f4\u00f2\3\2\2\2\u00f4\u00f5\3\2"+
		"\2\2\u00f5\35\3\2\2\2\u00f6\u00f4\3\2\2\2\u00f7\u00f8\7\36\2\2\u00f8\u0104"+
		"\b\20\1\2\u00f9\u00fa\7\37\2\2\u00fa\u0104\b\20\1\2\u00fb\u00fc\7 \2\2"+
		"\u00fc\u0104\b\20\1\2\u00fd\u00fe\7\34\2\2\u00fe\u0104\b\20\1\2\u00ff"+
		"\u0100\7\35\2\2\u0100\u0104\b\20\1\2\u0101\u0102\7!\2\2\u0102\u0104\b"+
		"\20\1\2\u0103\u00f7\3\2\2\2\u0103\u00f9\3\2\2\2\u0103\u00fb\3\2\2\2\u0103"+
		"\u00fd\3\2\2\2\u0103\u00ff\3\2\2\2\u0103\u0101\3\2\2\2\u0104\37\3\2\2"+
		"\2\25&,\65EMgv\u0081\u0089\u009a\u00a2\u00a9\u00b1\u00c7\u00cc\u00d7\u00f2"+
		"\u00f4\u0103";
	public static final ATN _ATN =
		new ATNDeserializer().deserialize(_serializedATN.toCharArray());
	static {
		_decisionToDFA = new DFA[_ATN.getNumberOfDecisions()];
		for (int i = 0; i < _ATN.getNumberOfDecisions(); i++) {
			_decisionToDFA[i] = new DFA(_ATN.getDecisionState(i), i);
		}
	}
}