package cz.upol.foolang;

import java.io.StringWriter;

import org.antlr.v4.runtime.ANTLRInputStream;
import org.antlr.v4.runtime.CommonTokenStream;

import cz.upol.foolang.ast.Node;
import cz.upol.foolang.parser.FooLangLexer;
import cz.upol.foolang.parser.FooLangParser;

public class Main {

	public static void main(String[] args) {
	}
	
	private static Node parse(String input) {
		FooLangLexer lexer = new FooLangLexer(new ANTLRInputStream(input));
		CommonTokenStream tokens = new CommonTokenStream(lexer);
		FooLangParser parser = new FooLangParser(tokens);
		return parser.source().node;
	}
	

}
