package cz.upol.foolang.ast;

/**
 * Modifikatory, ktere je mozne pouzit u metod a atributu
 */
public enum Modifier {
	
	PRIVATE   ("private"),
	PROTECTED ("protected"),
	PUBLIC    ("public"),
	STATIC    ("static");
	
	private String desc;
	
	private Modifier(String desc) {
		this.desc = desc;
	}
	
	@Override
	public String toString() {
		return desc;
	}

}
